% Here, add code to calculate and save any flow statistics that you might need later
% This script is called every N_SAVE_STATS timesteps

n_save=floor((TIME_STEP-1)/N_SAVE_STATS)+1; % Calculate the index for the saved array

% For example, calculate the mean and RMS of the velocity and scalar fields
U1_mean(n_save)=mean(mean(U1));
U1_rms(n_save)=sqrt(mean(mean((U1-U1_mean(n_save)).^2)));

U2_mean(n_save)=mean(mean(U2));
U2_rms(n_save)=sqrt(mean(mean((U2-U2_mean(n_save)).^2)));

if (SOLVE_U3) 
  U3_mean(n_save)=mean(mean(U3));
  U3_rms(n_save)=sqrt(mean(mean((U3-U3_mean(n_save)).^2)));
end

for n=1:N_TH
  TH_mean(n_save,n)=mean(mean(TH(:,:,n)));
  TH_rms(n_save,n)=sqrt(mean(mean((TH(:,:,n)-TH_mean(n_save,n)).^2)));
end


